// QWnd.h: interface for the CQWnd class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_QWND_H__9158FC5D_DF60_450D_8BE4_270C74A4F256__INCLUDED_)
#define AFX_QWND_H__9158FC5D_DF60_450D_8BE4_270C74A4F256__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
#include <windows.h>
#include <assert.h>

//Ϣӳ
#define QWND_DECLARE_MESSAGE_MAP(cls) public:virtual BOOL DispatchWindowProc(UINT uMsg,WPARAM wParam,LPARAM lParam);
#define QWND_BEGIN_MESSAGE_MAP(cls,base_cls) BOOL cls::DispatchWindowProc(UINT uMsg,WPARAM wParam,LPARAM lParam){
#define QWND_MESSAGE_MAP(id,fun) if(uMsg==id){return fun(uMsg,wParam,lParam);}
#define QWND_COMMAND_CODE_MAP(code,fun) if(uMsg==WM_COMMAND&&code == HIWORD(wParam)){return fun(uMsg,wParam,lParam);}  
#define QWND_COMMAND_ID_MAP(id,fun) if(uMsg==WM_COMMAND&&id==LOWORD(wParam)){return fun(uMsg,wParam,lParam);}  
#define QWND_COMMAND_MAP(id,code,fun) if(uMsg==WM_COMMAND&&id==LOWORD(wParam)&&code==HIWORD(wParam)){return fun(uMsg,wParam,lParam);}  
#define QWND_END_MESSAGE_MAP() return CQWnd::DispatchWindowProc(uMsg,wParam,lParam);}
#define QWND_END_MESSAGE_PARENT_MAP(cls) return cls::DispatchWindowProc(uMsg,wParam,lParam);}
#define QWND_END_MESSAGE_DEFAULT_MAP() return DefaultWindowProc(uMsg,wParam,lParam);}

//֧ȫֺ
WNDPROC GetSuperWndProcAddr();
//麯ӿϢӳ
class IMessageMap{
public:
	virtual BOOL DispatchWindowProc(UINT uMsg,WPARAM wParam,LPARAM lParam)=0;
};

//ڻ
class CQWnd:public IMessageMap{
QWND_DECLARE_MESSAGE_MAP(CQWnd)
public:
	CQWnd();
	virtual ~CQWnd();
public:
	BOOL Attach(HWND hWnd);
	BOOL CreateEx(DWORD dwExStyle,LPCTSTR lpszClassName,LPCTSTR lpszWindowName,DWORD dwStyle,int x,int y,int cx,int cy,HWND ParentWnd,HMENU mMenu,HINSTANCE hInstance);
	
	BOOL Detach(void);
	BOOL DestoryWindow();
	BOOL EnableWindow(BOOL bEnable);
	BOOL IsWindowVisible();
	//ȡشڶ
	CQWnd* GetWndFromHandle(HWND hWnd);
	BOOL MoveWindow(int X, int Y, int nWidth, int nHeight, BOOL bRepaint);
	BOOL ShowWindow(int nCmdShow);
	BOOL SetWindowText(LPCSTR lpString);
	BOOL SetMenu(HMENU hMenu);
	BOOL UpdateWindow(void);
	//麯Ԥ֪Ϣ
	virtual BOOL PreCreateWindow(CREATESTRUCT& cs);
	virtual HRESULT OnCreate(UINT uMsg,WPARAM wParam, LPARAM lParam);
	virtual HRESULT OnClose(UINT uMsg,WPARAM wParam, LPARAM lParam);
	virtual HRESULT OnDestroy(UINT uMsg,WPARAM wParam, LPARAM lParam);
	virtual HRESULT OnNcDestroy(UINT uMsg,WPARAM wParam, LPARAM lParam);
	virtual BOOL DefaultWindowProc(UINT uMsg,WPARAM wParam,LPARAM lParam);
public:
	//̬ں
	static LRESULT CALLBACK WindowProc(HWND hWnd,UINT uMsg,WPARAM wParam,LPARAM lParam);
public:
	//װھ
	HWND m_hWnd;
};
#endif // !defined(AFX_QWND_H__9158FC5D_DF60_450D_8BE4_270C74A4F256__INCLUDED_)
